Index: squid/src/acl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/acl.c,v
retrieving revision 1.1.1.3.4.3.2.3
retrieving revision 1.1.1.3.4.3.2.3.2.1
diff -u -r1.1.1.3.4.3.2.3 -r1.1.1.3.4.3.2.3.2.1
--- squid/src/acl.c	17 Jun 2001 12:39:53 -0000	1.1.1.3.4.3.2.3
+++ squid/src/acl.c	27 Aug 2001 21:48:19 -0000	1.1.1.3.4.3.2.3.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: acl.c,v 1.1.1.3.4.3.2.3 2001/06/17 12:39:53 serassio Exp $
+ * $Id: acl.c,v 1.1.1.3.4.3.2.3.2.1 2001/08/27 21:48:19 tolsty Exp $
  *
  * DEBUG: section 28    Access Control
  * AUTHOR: Duane Wessels
@@ -120,9 +119,6 @@
 		debug(28, 0) ("strtokFile: %s not found\n", fn);
 		return (NULL);
 	    }
-#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
-	    setmode(fileno(aclFile), O_TEXT);
-#endif
 	    aclFromFile = 1;
 	} else {
 	    return t;
@@ -456,7 +452,11 @@
     if (!decode_addr(addr1, &q->addr1, &q->mask)) {
 	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
-	debug(28, 0) ("aclParseIpData: Ignoring invalid IP acl entry: unknown first address '%s'\n", addr1);
+	debug(28, 0)
+
+	    
+	    ("aclParseIpData: Ignoring invalid IP acl entry: unknown first address '%s'\n",
+	    addr1);
 	safe_free(q);
 	return NULL;
     }
@@ -464,7 +464,11 @@
     if (*addr2 && !decode_addr(addr2, &q->addr2, &q->mask)) {
 	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
-	debug(28, 0) ("aclParseIpData: Ignoring invalid IP acl entry: unknown second address '%s'\n", addr2);
+	debug(28, 0)
+
+	    
+	    ("aclParseIpData: Ignoring invalid IP acl entry: unknown second address '%s'\n",
+	    addr2);
 	safe_free(q);
 	return NULL;
     }
@@ -472,7 +476,11 @@
     if (*mask && !decode_addr(mask, &q->mask, NULL)) {
 	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
-	debug(28, 0) ("aclParseIpData: Ignoring invalid IP acl entry: unknown netmask '%s'\n", mask);
+	debug(28, 0)
+
+	    
+	    ("aclParseIpData: Ignoring invalid IP acl entry: unknown netmask '%s'\n",
+	    mask);
 	safe_free(q);
 	return NULL;
     }
@@ -545,8 +553,7 @@
 		default:
 		    debug(28, 0) ("%s line %d: %s\n",
 			cfg_filename, config_lineno, config_input_line);
-		    debug(28, 0) ("aclParseTimeSpec: Bad Day '%c'\n",
-			*t);
+		    debug(28, 0) ("aclParseTimeSpec: Bad Day '%c'\n", *t);
 		    break;
 		}
 	    }
@@ -564,7 +571,8 @@
 	    if (q->start > q->stop) {
 		debug(28, 0) ("%s line %d: %s\n",
 		    cfg_filename, config_lineno, config_input_line);
-		debug(28, 0) ("aclParseTimeSpec: IGNORING Reversed time range\n");
+		debug(28,
+		    0) ("aclParseTimeSpec: IGNORING Reversed time range\n");
 		xfree(q);
 		return;
 	    }
@@ -602,7 +610,8 @@
 	    regerror(errcode, &comp, errbuf, sizeof errbuf);
 	    debug(28, 0) ("%s line %d: %s\n",
 		cfg_filename, config_lineno, config_input_line);
-	    debug(28, 0) ("aclParseRegexList: Invalid regular expression '%s': %s\n",
+	    debug(28,
+		0) ("aclParseRegexList: Invalid regular expression '%s': %s\n",
 		t, errbuf);
 	    continue;
 	}
@@ -677,7 +686,11 @@
 	new_acl = 1;
     } else {
 	if (acltype != A->type) {
-	    debug(28, 0) ("aclParseAclLine: ACL '%s' already exists with different type, skipping.\n", A->name);
+	    debug(28, 0)
+
+		
+		("aclParseAclLine: ACL '%s' already exists with different type, skipping.\n",
+		A->name);
 	    return;
 	}
 	debug(28, 3) ("aclParseAclLine: Appending to '%s'\n", aclname);
@@ -733,7 +746,8 @@
 	aclParseWordList(&A->data);
 	if (!proxy_auth_cache) {
 	    /* First time around, 7921 should be big enough */
-	    proxy_auth_cache = hash_create((HASHCMP *) strcmp, 7921, hash_string);
+	    proxy_auth_cache =
+		hash_create((HASHCMP *) strcmp, 7921, hash_string);
 	    assert(proxy_auth_cache);
 	}
 	break;
@@ -828,7 +842,8 @@
     if ((t = strtok(NULL, w_space)) == NULL) {
 	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
-	debug(28, 0) ("aclParseDenyInfoLine: missing 'error page' parameter.\n");
+	debug(28,
+	    0) ("aclParseDenyInfoLine: missing 'error page' parameter.\n");
 	return;
     }
     A = xcalloc(1, sizeof(acl_deny_info_list));
@@ -846,7 +861,10 @@
     if (A->acl_list == NULL) {
 	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
-	debug(28, 0) ("aclParseDenyInfoLine: deny_info line contains no ACL's, skipping\n");
+	debug(28, 0)
+
+	    
+	    ("aclParseDenyInfoLine: deny_info line contains no ACL's, skipping\n");
 	xfree(A);
 	return;
     }
@@ -881,7 +899,9 @@
     else {
 	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
-	debug(28, 0) ("aclParseAccessLine: expecting 'allow' or 'deny', got '%s'.\n", t);
+	debug(28,
+	    0) ("aclParseAccessLine: expecting 'allow' or 'deny', got '%s'.\n",
+	    t);
 	xfree(A);
 	return;
     }
@@ -913,7 +933,8 @@
     if (A->acl_list == NULL) {
 	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
-	debug(28, 0) ("aclParseAccessLine: Access line contains no ACL's, skipping\n");
+	debug(28, 0)
+	    ("aclParseAccessLine: Access line contains no ACL's, skipping\n");
 	xfree(A);
 	return;
     }
@@ -991,7 +1012,8 @@
     debug(28, 3) ("aclMatchUser: checking '%s'\n", user);
     while (data) {
 	debug(28, 3) ("aclMatchUser: looking for '%s'\n", data->key);
-	if (strcmp(data->key, "REQUIRED") == 0 && *user != '\0' && strcmp(user, "-") != 0)
+	if (strcmp(data->key, "REQUIRED") == 0 && *user != '\0'
+	    && strcmp(user, "-") != 0)
 	    return 1;
 	if (strcmp(data->key, user) == 0)
 	    return 1;
@@ -1001,7 +1023,8 @@
 }
 
 static int
-aclDecodeProxyAuth(const char *proxy_auth, char **user, char **password, char *buf, size_t bufsize)
+aclDecodeProxyAuth(const char *proxy_auth, char **user, char **password,
+    char *buf, size_t bufsize)
 {
     char *sent_auth;
     char *cleartext;
@@ -1009,7 +1032,9 @@
 	return 0;
     debug(28, 6) ("aclDecodeProxyAuth: header = '%s'\n", proxy_auth);
     if (strncasecmp(proxy_auth, "Basic ", 6) != 0) {
-	debug(28, 1) ("aclDecodeProxyAuth: Unsupported proxy-auth scheme, '%s'\n", proxy_auth);
+	debug(28,
+	    1) ("aclDecodeProxyAuth: Unsupported proxy-auth scheme, '%s'\n",
+	    proxy_auth);
 	return 0;
     }
     proxy_auth += 6;		/* "Basic " */
@@ -1033,7 +1058,11 @@
     if ((*password = strchr(*user, ':')) != NULL)
 	*(*password)++ = '\0';
     if (*password == NULL) {
-	debug(28, 1) ("aclDecodeProxyAuth: no password in proxy authorization header '%s'\n", proxy_auth);
+	debug(28, 1)
+
+	    
+	    ("aclDecodeProxyAuth: no password in proxy authorization header '%s'\n",
+	    proxy_auth);
 	return 0;
     }
     if (**password == '\0') {
@@ -1053,13 +1082,15 @@
  */
 
 static int
-aclMatchProxyAuth(wordlist * data, const char *proxy_auth, acl_proxy_auth_user * auth_user, aclCheck_t * checklist)
+aclMatchProxyAuth(wordlist * data, const char *proxy_auth,
+    acl_proxy_auth_user * auth_user, aclCheck_t * checklist)
 {
     /* checklist is used to register user name when identified, nothing else */
     LOCAL_ARRAY(char, login_buf, USER_IDENT_SZ);
     char *user, *password;
 
-    if (!aclDecodeProxyAuth(proxy_auth, &user, &password, login_buf, sizeof(login_buf)))
+    if (!aclDecodeProxyAuth(proxy_auth, &user, &password, login_buf,
+	    sizeof(login_buf)))
 	/* No or invalid Proxy-Auth header */
 	return -2;
 
@@ -1078,7 +1109,8 @@
 	if (auth_user->passwd_ok != 1) {
 	    /* password was checked but did not match */
 	    assert(auth_user->passwd_ok == 0);
-	    debug(28, 4) ("aclMatchProxyAuth: authentication failed for user '%s'\n",
+	    debug(28,
+		4) ("aclMatchProxyAuth: authentication failed for user '%s'\n",
 		user);
 	    aclFreeProxyAuthUser(auth_user);
 	    /*
@@ -1094,7 +1126,8 @@
 	    debug(28, 4) ("aclMatchProxyAuth: user '%s' validated OK\n", user);
 	    /* store validated user in hash, after filling in expiretime */
 	    xstrncpy(checklist->request->user_ident, user, USER_IDENT_SZ);
-	    auth_user->expiretime = current_time.tv_sec + Config.authenticateTTL;
+	    auth_user->expiretime =
+		current_time.tv_sec + Config.authenticateTTL;
 	    auth_user->ip_expiretime = squid_curtime + Config.authenticateIpTTL;
 	    auth_user->ipaddr = checklist->src_addr;
 	    hash_join(proxy_auth_cache, (hash_link *) auth_user);
@@ -1123,7 +1156,9 @@
 	    return aclMatchUser(data, user);
 	} else {
 	    /* user has switched to another IP addr */
-	    debug(28, 1) ("aclMatchProxyAuth: user '%s' has changed IP address\n", user);
+	    debug(28,
+		1) ("aclMatchProxyAuth: user '%s' has changed IP address\n",
+		user);
 	    /* remove this user from the hash, making him unknown */
 	    hash_remove_link(proxy_auth_cache, (hash_link *) auth_user);
 	    aclFreeProxyAuthUser(auth_user);
@@ -1132,7 +1167,8 @@
 	}
     } else {
 	/* password mismatch/timeout */
-	debug(28, 4) ("aclMatchProxyAuth: user '%s' password mismatch/timeout\n",
+	debug(28,
+	    4) ("aclMatchProxyAuth: user '%s' password mismatch/timeout\n",
 	    user);
 	/* remove this user from the hash, making him unknown */
 	hash_remove_link(proxy_auth_cache, (hash_link *) auth_user);
@@ -1170,7 +1206,8 @@
      * in aclMatchProxyAuth, and we should never get this far.
      */
     assert(ok);
-    debug(28, 4) ("aclLookupProxyAuthStart: going to ask authenticator on %s\n", user);
+    debug(28, 4) ("aclLookupProxyAuthStart: going to ask authenticator on %s\n",
+	user);
     /* we must still check this user's password */
     auth_user = memAllocate(MEM_ACL_PROXY_AUTH_USER);
     auth_user->user = xstrdup(user);
@@ -1178,8 +1215,7 @@
     auth_user->passwd_ok = -1;
     auth_user->expiretime = -1;
     checklist->auth_user = auth_user;
-    authenticateStart(checklist->auth_user, aclLookupProxyAuthDone,
-	checklist);
+    authenticateStart(checklist->auth_user, aclLookupProxyAuthDone, checklist);
 }
 
 static int
@@ -1320,7 +1356,8 @@
 	return aclMatchDomainList(&ae->data, "none");
 	/* NOTREACHED */
     case ACL_SRC_DOMAIN:
-	fqdn = fqdncache_gethostbyaddr(checklist->src_addr, FQDN_LOOKUP_IF_MISS);
+	fqdn =
+	    fqdncache_gethostbyaddr(checklist->src_addr, FQDN_LOOKUP_IF_MISS);
 	if (fqdn) {
 	    return aclMatchDomainList(&ae->data, fqdn);
 	} else if (checklist->state[ACL_SRC_DOMAIN] == ACL_LOOKUP_NONE) {
@@ -1346,7 +1383,8 @@
 	return aclMatchRegex(ae->data, "none");
 	/* NOTREACHED */
     case ACL_SRC_DOM_REGEX:
-	fqdn = fqdncache_gethostbyaddr(checklist->src_addr, FQDN_LOOKUP_IF_MISS);
+	fqdn =
+	    fqdncache_gethostbyaddr(checklist->src_addr, FQDN_LOOKUP_IF_MISS);
 	if (fqdn) {
 	    return aclMatchRegex(ae->data, fqdn);
 	} else if (checklist->state[ACL_SRC_DOMAIN] == ACL_LOOKUP_NONE) {
@@ -1423,7 +1461,11 @@
 	    header = httpHeaderGetStr(&checklist->request->header,
 		HDR_AUTHORIZATION);
 #else
-	    debug(28, 1) ("aclMatchAcl: proxy_auth %s not applicable on accelerated requests.\n", ae->name);
+	    debug(28, 1)
+
+		
+		("aclMatchAcl: proxy_auth %s not applicable on accelerated requests.\n",
+		ae->name);
 	    return -1;
 #endif
 	}
@@ -1434,9 +1476,7 @@
 	r->flags.used_proxy_auth = 1;
 	/* Check the password */
 	switch (aclMatchProxyAuth(ae->data,
-		header,
-		checklist->auth_user,
-		checklist)) {
+		header, checklist->auth_user, checklist)) {
 	case 0:
 	    /* Correct password, but was not allowed in this ACL */
 	    return 0;
@@ -1549,20 +1589,17 @@
 	if (checklist->state[ACL_DST_IP] == ACL_LOOKUP_NEEDED) {
 	    checklist->state[ACL_DST_IP] = ACL_LOOKUP_PENDING;
 	    ipcache_nbgethostbyname(checklist->request->host,
-		aclLookupDstIPDone,
-		checklist);
+		aclLookupDstIPDone, checklist);
 	    return;
 	} else if (checklist->state[ACL_DST_ASN] == ACL_LOOKUP_NEEDED) {
 	    checklist->state[ACL_DST_ASN] = ACL_LOOKUP_PENDING;
 	    ipcache_nbgethostbyname(checklist->request->host,
-		aclLookupDstIPforASNDone,
-		checklist);
+		aclLookupDstIPforASNDone, checklist);
 	    return;
 	} else if (checklist->state[ACL_SRC_DOMAIN] == ACL_LOOKUP_NEEDED) {
 	    checklist->state[ACL_SRC_DOMAIN] = ACL_LOOKUP_PENDING;
 	    fqdncache_nbgethostbyaddr(checklist->src_addr,
-		aclLookupSrcFQDNDone,
-		checklist);
+		aclLookupSrcFQDNDone, checklist);
 	    return;
 	} else if (checklist->state[ACL_DST_DOMAIN] == ACL_LOOKUP_NEEDED) {
 	    ia = ipcacheCheckNumeric(checklist->request->host);
@@ -1573,8 +1610,7 @@
 	    checklist->dst_addr = ia->in_addrs[0];
 	    checklist->state[ACL_DST_DOMAIN] = ACL_LOOKUP_PENDING;
 	    fqdncache_nbgethostbyaddr(checklist->dst_addr,
-		aclLookupDstFQDNDone,
-		checklist);
+		aclLookupDstFQDNDone, checklist);
 	    return;
 	} else if (checklist->state[ACL_PROXY_AUTH] == ACL_LOOKUP_NEEDED) {
 	    debug(28, 3) ("aclCheck: checking password via authenticator\n");
@@ -1597,7 +1633,10 @@
 		checklist->state[ACL_IDENT] = ACL_LOOKUP_PENDING;
 		return;
 	    } else {
-		debug(28, 1) ("aclCheck: Can't start ident lookup. No client connection\n");
+		debug(28, 1)
+
+		    
+		    ("aclCheck: Can't start ident lookup. No client connection\n");
 		cbdataUnlock(checklist->conn);
 		checklist->conn = NULL;
 		allow = 0;
@@ -1667,7 +1706,8 @@
     aclCheck_t *checklist = data;
     if (ident) {
 	xstrncpy(checklist->ident, ident, sizeof(checklist->ident));
-	xstrncpy(checklist->request->user_ident, ident, sizeof(checklist->request->user_ident));
+	xstrncpy(checklist->request->user_ident, ident,
+	    sizeof(checklist->request->user_ident));
     } else {
 	xstrncpy(checklist->ident, "-", sizeof(checklist->ident));
     }
@@ -1676,7 +1716,8 @@
      * over and over on persistent connections
      */
     if (cbdataValid(checklist->conn) && !checklist->conn->ident[0])
-	xstrncpy(checklist->conn->ident, checklist->ident, sizeof(checklist->conn->ident));
+	xstrncpy(checklist->conn->ident, checklist->ident,
+	    sizeof(checklist->conn->ident));
     aclCheck(checklist);
 }
 #endif
@@ -1728,9 +1769,7 @@
 }
 
 aclCheck_t *
-aclChecklistCreate(const acl_access * A,
-    request_t * request,
-    const char *ident)
+aclChecklistCreate(const acl_access * A, request_t * request, const char *ident)
 {
     int i;
     aclCheck_t *checklist = memAllocate(MEM_ACLCHECK_T);
@@ -1758,7 +1797,7 @@
 }
 
 void
-aclNBCheck(aclCheck_t * checklist, PF callback, void *callback_data)
+aclNBCheck(aclCheck_t * checklist, PF * callback, void *callback_data)
 {
     checklist->callback = callback;
     checklist->callback_data = callback_data;
@@ -1955,8 +1994,16 @@
     }
     if (ret == 0) {
 	debug(28, 0) ("WARNING: '%s' is a subdomain of '%s'\n", d1, d2);
-	debug(28, 0) ("WARNING: because of this '%s' is ignored to keep splay tree searching predictable\n", a);
-	debug(28, 0) ("WARNING: You should probably remove '%s' from the ACL named '%s'\n", d1, AclMatchedName);
+	debug(28, 0)
+
+	    
+	    ("WARNING: because of this '%s' is ignored to keep splay tree searching predictable\n",
+	    a);
+	debug(28, 0)
+
+	    
+	    ("WARNING: You should probably remove '%s' from the ACL named '%s'\n",
+	    d1, AclMatchedName);
     }
     return ret;
 }
@@ -2064,10 +2111,7 @@
 	    t->weekbits & ACL_THURSDAY ? 'H' : '-',
 	    t->weekbits & ACL_FRIDAY ? 'F' : '-',
 	    t->weekbits & ACL_SATURDAY ? 'A' : '-',
-	    t->start / 60,
-	    t->start % 60,
-	    t->stop / 60,
-	    t->stop % 60);
+	    t->start / 60, t->start % 60, t->stop / 60, t->stop % 60);
 	wordlistAdd(&W, buf);
 	t = t->next;
     }
@@ -2293,7 +2337,11 @@
     if (!decode_eth(eth, q->eth)) {
 	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
-	debug(28, 0) ("aclParseArpData: Ignoring invalid ARP acl entry: can't parse '%s'\n", eth);
+	debug(28, 0)
+
+	    
+	    ("aclParseArpData: Ignoring invalid ARP acl entry: can't parse '%s'\n",
+	    eth);
 	safe_free(q);
 	return NULL;
     }
@@ -2422,8 +2470,7 @@
 	    arpReq.arp_ha.sa_data[2] & 0xff,
 	    arpReq.arp_ha.sa_data[3] & 0xff,
 	    arpReq.arp_ha.sa_data[4] & 0xff,
-	    arpReq.arp_ha.sa_data[5] & 0xff,
-	    ifr->ifr_name);
+	    arpReq.arp_ha.sa_data[5] & 0xff, ifr->ifr_name);
 	/* Do lookup */
 	*Top = splay_splay(&arpReq.arp_ha.sa_data, *Top, aclArpCompare);
 	/* Return if match, otherwise continue to other interfaces */
Index: squid/src/aiops.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/aiops.c,v
retrieving revision 1.1.1.3.4.2.2.1
retrieving revision 1.1.1.3.4.2.2.1.2.1
diff -u -r1.1.1.3.4.2.2.1 -r1.1.1.3.4.2.2.1.2.1
--- squid/src/aiops.c	6 Jan 2001 12:40:12 -0000	1.1.1.3.4.2.2.1
+++ squid/src/aiops.c	27 Aug 2001 21:48:19 -0000	1.1.1.3.4.2.2.1.2.1
@@ -1,5 +1,5 @@
 /*
- * $Id: aiops.c,v 1.1.1.3.4.2.2.1 2001/01/06 12:40:12 hno Exp $
+ * $Id: aiops.c,v 1.1.1.3.4.2.2.1.2.1 2001/08/27 21:48:19 tolsty Exp $
  *
  * DEBUG: section 43    AIOPS
  * AUTHOR: Stewart Forster <slf@connect.com.au>
@@ -34,11 +34,24 @@
 
 #include "squid.h"
 
+#if USE_ASYNC_IO
+
+#ifdef _SQUID_MSWIN_
+#include <process.h>
+
+#define pthread_t HANDLE
+#define pthread_mutex_t HANDLE
+#define pthread_cond_t HANDLE
+#define AIO_PROPER_MUTEX 1
+#endif
+
 #include	<stdio.h>
 #include	<sys/types.h>
 #include	<sys/stat.h>
 #include	<fcntl.h>
+#ifndef _SQUID_MSWIN_
 #include	<pthread.h>
+#endif
 #include	<errno.h>
 #include	<dirent.h>
 #include	<signal.h>
@@ -48,14 +61,15 @@
 
 #define RIDICULOUS_LENGTH	4096
 
-#if defined(_SQUID_LINUX_)
+#if defined(_SQUID_LINUX_) || defined(_SQUID_MSWIN_)
 /* Linux requires proper use of mutexes or it will segfault deep in the
  * thread libraries. Observed on Alpha SMP Linux 2.2.10-ac12.
  */
 #define USE_PROPER_MUTEX 1
 #endif
 
-enum _aio_thread_status {
+enum _aio_thread_status
+{
     _THREAD_STARTING = 0,
     _THREAD_WAITING,
     _THREAD_BUSY,
@@ -63,7 +77,8 @@
     _THREAD_DONE
 };
 
-enum _aio_request_type {
+enum _aio_request_type
+{
     _AIO_OP_NONE = 0,
     _AIO_OP_OPEN,
     _AIO_OP_READ,
@@ -74,7 +89,8 @@
     _AIO_OP_STAT
 };
 
-typedef struct aio_request_t {
+typedef struct aio_request_t
+{
     enum _aio_request_type request_type;
     int cancelled;
     char *path;
@@ -92,18 +108,24 @@
     struct stat *statp;
     aio_result_t *resultp;
     struct aio_request_t *next;
-} aio_request_t;
+}
+aio_request_t;
 
 
-typedef struct aio_thread_t {
+typedef struct aio_thread_t
+{
     pthread_t thread;
     enum _aio_thread_status status;
     pthread_mutex_t mutex;	/* Mutex for testing condition variable */
     pthread_cond_t cond;	/* Condition variable */
-    struct aio_request_t *volatile req;		/* set by main, cleared by thread */
+    struct aio_request_t *volatile req;	/* set by main, cleared by thread */
     struct aio_request_t *processed_req;	/* reminder to main */
     struct aio_thread_t *next;
-} aio_thread_t;
+#ifdef _SQUID_MSWIN_
+    int volatile exit;
+#endif
+}
+aio_thread_t;
 
 
 int aio_cancel(aio_result_t *);
@@ -120,7 +142,11 @@
 static void aio_queue_request(aio_request_t *);
 static void aio_process_request_queue(void);
 static void aio_cleanup_request(aio_request_t *);
+#ifdef _SQUID_MSWIN_
+static DWORD WINAPI aio_thread_loop(void *);
+#else
 static void *aio_thread_loop(void *);
+#endif
 static void aio_do_open(aio_request_t *);
 static void aio_do_read(aio_request_t *);
 static void aio_do_write(aio_request_t *);
@@ -145,10 +171,75 @@
 static aio_thread_t *wait_threads = NULL;
 static aio_thread_t *busy_threads_head = NULL;
 static aio_thread_t *busy_threads_tail = NULL;
+#ifndef _SQUID_MSWIN_
 static pthread_attr_t globattr;
 static struct sched_param globsched;
+#endif
 static pthread_t main_thread;
 
+#ifdef _SQUID_MSWIN_
+int
+pthread_mutex_init(pthread_mutex_t * pmutex, void *unused)
+{
+    *pmutex = CreateMutex(NULL, FALSE, NULL);
+    return !(*pmutex);
+}
+
+int
+pthread_mutex_lock(pthread_mutex_t * mutex)
+{
+    DWORD r;
+    r = WaitForSingleObject(*mutex, INFINITE);
+    return (r == WAIT_OBJECT_0) ? 0 : EINVAL;
+}
+
+int
+pthread_mutex_trylock(pthread_mutex_t * mutex)
+{
+    DWORD r;
+    r = WaitForSingleObject(*mutex, 0);
+    return (r == WAIT_OBJECT_0) ? 0 : (r == WAIT_TIMEOUT) ? EBUSY : EINVAL;
+}
+
+int
+pthread_mutex_unlock(pthread_mutex_t * mutex)
+{
+    DWORD r;
+
+    r = ReleaseMutex(*mutex);
+    assert(r);
+    Sleep(0);
+    return !r;
+}
+
+int
+pthread_cond_init(pthread_cond_t * pcond, void *unused)
+{
+    *pcond = CreateSemaphore(NULL, 0, 1, NULL);
+    return !(*pcond);
+}
+
+int
+pthread_cond_wait(pthread_cond_t * cond, pthread_mutex_t * mutex)
+{
+    DWORD r;
+
+    pthread_mutex_unlock(mutex);
+    r = WaitForSingleObject(*cond, INFINITE);
+    assert(r == WAIT_OBJECT_0);
+    assert(!pthread_mutex_lock(mutex));
+    return 0;
+}
+
+int
+pthread_cond_signal(pthread_cond_t * cond)
+{
+    assert(ReleaseSemaphore(*cond, 1, NULL));
+    Sleep(0);
+    return 0;
+}
+#endif
+
 static void
 aio_init(void)
 {
@@ -158,7 +249,9 @@
     if (aio_initialised)
 	return;
 
+#ifndef _SQUID_MSWIN_
     pthread_attr_init(&globattr);
+#endif
 #if HAVE_PTHREAD_ATTR_SETSCOPE
 #if defined(_SQUID_SGI_)
     /* 
@@ -170,12 +263,20 @@
     pthread_attr_setscope(&globattr, PTHREAD_SCOPE_SYSTEM);
 #endif
 #endif
+#ifndef _SQUID_MSWIN_
     globsched.sched_priority = 1;
     main_thread = pthread_self();
+#else
+    DuplicateHandle(GetCurrentProcess(), GetCurrentThread(),
+	GetCurrentProcess(), &main_thread, 0, FALSE, DUPLICATE_SAME_ACCESS);
+    assert(main_thread);
+#endif
 #if HAVE_PTHREAD_SETSCHEDPARAM
     pthread_setschedparam(main_thread, SCHED_OTHER, &globsched);
 #endif
+#ifndef _SQUID_MSWIN_
     globsched.sched_priority = 2;
+#endif
 #if HAVE_PTHREAD_ATTR_SETSCHEDPARAM
     pthread_attr_setschedparam(&globattr, &globsched);
 #endif
@@ -199,7 +300,14 @@
 	}
 	threadp->req = NULL;
 	threadp->processed_req = NULL;
-	if (pthread_create(&threadp->thread, &globattr, aio_thread_loop, threadp)) {
+#ifdef _SQUID_MSWIN_
+	if (!(threadp->thread =
+		(HANDLE) _beginthreadex(NULL, 0, aio_thread_loop, threadp,
+		    CREATE_SUSPENDED, NULL))) {
+#else
+	if (pthread_create(&threadp->thread, &globattr, aio_thread_loop,
+		threadp)) {
+#endif
 	    fprintf(stderr, "Thread creation failed\n");
 	    threadp->status = _THREAD_FAILED;
 	    continue;
@@ -209,6 +317,9 @@
 #if AIO_PROPER_MUTEX
 	pthread_mutex_lock(&threadp->mutex);
 #endif
+#ifdef _SQUID_MSWIN_
+	ResumeThread(threadp->thread);
+#endif
     }
 
     /* Create request pool */
@@ -217,13 +328,46 @@
     aio_initialised = 1;
 }
 
+#ifdef _SQUID_MSWIN_
+void
+aio_shutdown(void)
+{
+    aio_thread_t *threadp;
+    int i;
+    HANDLE hthreads[NUMTHREADS];
+
+    if (!aio_initialised)
+	return;
+
+    for (i = 0; i < NUMTHREADS; i++) {
+	threadp = &threads[i];
+	threadp->exit = 1;
+	hthreads[i] = threadp->thread;
+	pthread_cond_signal(&threadp->cond);
+	pthread_mutex_unlock(&threadp->mutex);
+    }
+    CloseHandle(main_thread);
+    {
+	DWORD r = WaitForMultipleObjects(NUMTHREADS, hthreads, TRUE, INFINITE);
+	assert(r >= WAIT_OBJECT_0 && r < WAIT_OBJECT_0 + NUMTHREADS);
+    }
+    for (i = 0; i < NUMTHREADS; i++) {
+	CloseHandle(hthreads[i]);
+    }
+    aio_initialised = 0;
+}
 
+DWORD WINAPI
+#else
 static void *
+#endif				/* _SQUID_MSWIN_ */
 aio_thread_loop(void *ptr)
 {
     aio_thread_t *threadp = ptr;
     aio_request_t *request;
+#ifndef _SQUID_MSWIN_
     sigset_t new;
+#endif
 #if !AIO_PROPER_MUTEX
     struct timespec wait_time;
 #endif
@@ -233,7 +377,7 @@
      * the parent squid thread.  Causes havoc with mutex's and
      * condition waits otherwise
      */
-
+#ifndef _SQUID_MSWIN_
     sigemptyset(&new);
     sigaddset(&new, SIGPIPE);
     sigaddset(&new, SIGCHLD);
@@ -251,6 +395,7 @@
 #if HAVE_PTHREAD_SIGMASK
     pthread_sigmask(SIG_BLOCK, &new, NULL);
 #else
+#endif
     /*
      * Some versions of AIX, 4.2 at least, do not have pthread_sigmask
      * in the pthreads library.  They still use the older sigthreadmask
@@ -264,6 +409,13 @@
 #if AIO_PROPER_MUTEX
 	while (threadp->req == NULL) {
 	    threadp->status = _THREAD_WAITING;
+#ifdef _SQUID_MSWIN_
+	    if (threadp->exit) {
+		CloseHandle(threadp->mutex);
+		CloseHandle(threadp->cond);
+		return 0;
+	    }
+#endif
 	    pthread_cond_wait(&threadp->cond, &threadp->mutex);
 	}
 #else
@@ -319,7 +471,11 @@
 	}
 	threadp->req = NULL;	/* tells main thread that we are done */
     }				/* while */
+#ifdef _SQUID_MSWIN_
+    return 0;
+#else
     return NULL;
+#endif
 }				/* aio_thread_loop */
 
 static void
@@ -373,35 +529,51 @@
 	    queue_low = request_queue_len;
 	if (squid_curtime >= (last_warn + 15) &&
 	    squid_curtime >= (high_start + 3)) {
-	    debug(43, 1) ("aio_queue_request: WARNING - Running out of I/O threads\n");
-	    debug(43, 2) ("aio_queue_request: Queue Length: current=%d, high=%d, low=%d, duration=%d\n",
-		request_queue_len, queue_high, queue_low, squid_curtime - high_start);
-	    debug(43, 1) ("aio_queue_request: Perhaps you should increase NUMTHREADS\n");
-	    debug(43, 1) ("aio_queue_request: Or install more disks to share the load\n");
-	    debug(43, 3) ("aio_queue_request: First %d items on request queue\n", NUMTHREADS);
+	    debug(43, 1)
+		("aio_queue_request: WARNING - Running out of I/O threads\n");
+	    debug(43, 2)
+		
+		("aio_queue_request: Queue Length: current=%d, high=%d, low=%d, duration=%d\n",
+		request_queue_len, queue_high, queue_low,
+		squid_curtime - high_start);
+	    debug(43, 1)
+		("aio_queue_request: Perhaps you should increase NUMTHREADS\n");
+	    debug(43, 1)
+		("aio_queue_request: Or install more disks to share the load\n");
+	    debug(43, 3)
+		("aio_queue_request: First %d items on request queue\n", NUMTHREADS);
 	    rp = request_queue_head;
 	    for (i = 1; i <= NUMTHREADS; i++) {
 		switch (rp->request_type) {
 		case _AIO_OP_OPEN:
-		    debug(43, 3) ("aio_queue_request: %d : open -> %s\n", i, rp->path);
+		    debug(43, 3) ("aio_queue_request: %d : open -> %s\n",
+			i, rp->path);
 		    break;
 		case _AIO_OP_READ:
-		    debug(43, 3) ("aio_queue_request: %d : read -> FD = %d\n", i, rp->fd);
+		    debug(43, 3) ("aio_queue_request: %d : read -> FD = %d\n",
+			i, rp->fd);
 		    break;
 		case _AIO_OP_WRITE:
-		    debug(43, 3) ("aio_queue_request: %d : write -> FD = %d\n", i, rp->fd);
+		    debug(43, 3) ("aio_queue_request: %d : write -> FD = %d\n",
+			i, rp->fd);
 		    break;
 		case _AIO_OP_CLOSE:
-		    debug(43, 3) ("aio_queue_request: %d : close -> FD = %d\n", i, rp->fd);
+		    debug(43, 3) ("aio_queue_request: %d : close -> FD = %d\n",
+			i, rp->fd);
 		    break;
 		case _AIO_OP_UNLINK:
-		    debug(43, 3) ("aio_queue_request: %d : unlink -> %s\n", i, rp->path);
+		    debug(43, 3) ("aio_queue_request: %d : unlink -> %s\n",
+			i, rp->path);
 		    break;
 		case _AIO_OP_STAT:
-		    debug(43, 3) ("aio_queue_request: %d : stat -> %s\n", i, rp->path);
+		    debug(43, 3) ("aio_queue_request: %d : stat -> %s\n",
+			i, rp->path);
 		    break;
 		default:
-		    debug(43, 1) ("aio_queue_request: %d : Unimplemented request type: %d\n", i, rp->request_type);
+		    debug(43, 1)
+			
+			("aio_queue_request: %d : Unimplemented request type: %d\n",
+			i, rp->request_type);
 		    break;
 		}
 		if ((rp = rp->next) == NULL)
@@ -413,8 +585,10 @@
 	high_start = 0;
     }
     if (request_queue_len > RIDICULOUS_LENGTH) {
-	debug(43, 0) ("aio_queue_request: Async request queue growing uncontrollably!\n");
-	debug(43, 0) ("aio_queue_request: Syncing pending I/O operations.. (blocking)\n");
+	debug(43, 0)
+	    ("aio_queue_request: Async request queue growing uncontrollably!\n");
+	debug(43, 0)
+	    ("aio_queue_request: Syncing pending I/O operations.. (blocking)\n");
 	aio_sync();
 	debug(43, 0) ("aio_queue_request: Synced\n");
     }
@@ -518,14 +692,14 @@
 	    threadp->processed_req->resultp = NULL;
 	    return 0;
 	}
-    for (requestp = request_queue_head; requestp != NULL; requestp = requestp->next)
-	if (requestp->resultp == resultp) {
+    for (requestp = request_queue_head; requestp != NULL;
+	requestp = requestp->next) if (requestp->resultp == resultp) {
 	    requestp->cancelled = 1;
 	    requestp->resultp = NULL;
 	    return 0;
 	}
-    for (requestp = request_done_head; requestp != NULL; requestp = requestp->next)
-	if (requestp->resultp == resultp) {
+    for (requestp = request_done_head; requestp != NULL;
+	requestp = requestp->next) if (requestp->resultp == resultp) {
 	    requestp->cancelled = 1;
 	    requestp->resultp = NULL;
 	    return 0;
@@ -571,9 +745,9 @@
     requestp->err = errno;
 }
 
-
 int
-aio_read(int fd, char *bufp, int bufs, off_t offset, int whence, aio_result_t * resultp)
+aio_read(int fd, char *bufp, int bufs, off_t offset, int whence,
+    aio_result_t * resultp)
 {
     aio_request_t *requestp;
 
@@ -612,7 +786,8 @@
 
 
 int
-aio_write(int fd, char *bufp, int bufs, off_t offset, int whence, aio_result_t * resultp)
+aio_write(int fd, char *bufp, int bufs, off_t offset, int whence,
+    aio_result_t * resultp)
 {
     aio_request_t *requestp;
 
@@ -640,7 +815,6 @@
     return 0;
 }
 
-
 static void
 aio_do_write(aio_request_t * requestp)
 {
@@ -648,7 +822,6 @@
     requestp->err = errno;
 }
 
-
 int
 aio_close(int fd, aio_result_t * resultp)
 {
@@ -669,7 +842,6 @@
     return 0;
 }
 
-
 static void
 aio_do_close(aio_request_t * requestp)
 {
@@ -677,7 +849,6 @@
     requestp->err = errno;
 }
 
-
 int
 aio_stat(const char *path, struct stat *sb, aio_result_t * resultp)
 {
@@ -698,7 +869,8 @@
     }
     strncpy(requestp->path, path, len);
     requestp->statp = sb;
-    if ((requestp->tmpstatp = (struct stat *) xmalloc(sizeof(struct stat))) == NULL) {
+    if ((requestp->tmpstatp =
+	    (struct stat *) xmalloc(sizeof(struct stat))) == NULL) {
 	xfree(requestp->path);
 	memPoolFree(aio_request_pool, requestp);
 	errno = ENOMEM;
@@ -712,7 +884,6 @@
     return 0;
 }
 
-
 static void
 aio_do_stat(aio_request_t * requestp)
 {
@@ -720,7 +891,6 @@
     requestp->err = errno;
 }
 
-
 int
 aio_unlink(const char *path, aio_result_t * resultp)
 {
@@ -748,7 +918,6 @@
     return 0;
 }
 
-
 static void
 aio_do_unlink(aio_request_t * requestp)
 {
@@ -797,10 +966,9 @@
 	prev = NULL;
 	threadp = busy_threads_head;
 	while (threadp) {
-	    debug(43, 9) ("aio_poll_threads: %p: request type %d -> status %d\n",
-		threadp,
-		threadp->processed_req->request_type,
-		threadp->status);
+	    debug(43, 9)
+		("aio_poll_threads: %p: request type %d -> status %d\n",
+		threadp, threadp->processed_req->request_type, threadp->status);
 #if AIO_PROPER_MUTEX
 	    if (threadp->req == NULL)
 		if (pthread_mutex_trylock(&threadp->mutex) == 0)
@@ -859,7 +1027,8 @@
     resultp = requestp->resultp;
     cancelled = requestp->cancelled;
     aio_debug(requestp);
-    debug(43, 5) ("DONE: %d -> %d\n", requestp->ret, requestp->err);
+    errno = requestp->err;
+    debug(43, 5) ("--> DONE: %d -> %s\n", requestp->ret, xstrerror());
     aio_cleanup_request(requestp);
     if (cancelled)
 	goto AIO_REPOLL;
@@ -869,7 +1038,8 @@
 int
 aio_operations_pending(void)
 {
-    return request_queue_len + (request_done_head != NULL) + (busy_threads_head != NULL);
+    return request_queue_len + (request_done_head !=
+	NULL) + (busy_threads_head != NULL);
 }
 
 int
@@ -926,3 +1096,4 @@
 	break;
     }
 }
+#endif /*USE_ASYNC_IO */
